<!DOCTYPE html>

<html>

<head>
    {{ template "prelude" }}

    <script>
        async function load_requests_plot() {
            const data = await load_time_series(
                "rate(caddy_http_requests_total{server=\"srv0\"}[2m])",
                metric => null,
            );

            Plotly.newPlot(
                document.getElementById("requests"),
                data,
                {
                    title: "Anfragen",
                    yaxis: {
                        ticksuffix: "/s",
                    },
                }
            );
        }

        async function load_errors_plot() {
            const data = await load_time_series(
                "rate(caddy_http_requests_errors_total{server=\"srv0\"}[2m])",
                metric => null,
            );

            Plotly.newPlot(
                document.getElementById("errors"),
                data,
                {
                    title: "Fehler",
                    yaxis: {
                        ticksuffix: "/s",
                    },
                }
            );
        }

        async function load_duration_plot() {
            const data = await load_histogram("sum(caddy_http_response_duration_seconds_bucket{server=\"srv0\"}) by (le)");

            Plotly.newPlot(
                document.getElementById("duration"),
                data,
                {
                    title: "Antwort-Dauer",
                    xaxis: {
                        ticksuffix: "s",
                    },
                }
            );
        }

        async function load_size_plot() {
            const data = await load_histogram("sum(caddy_http_response_size_bytes_bucket{server=\"srv0\"}) by (le)");

            Plotly.newPlot(
                document.getElementById("size"),
                data,
                {
                    title: "Antwort-Größe",
                    xaxis: {
                        ticksuffix: "B",
                    },
                }
            );
        }

        async function load_upstreams_table() {
            const data = await load_values("caddy_reverse_proxy_upstreams_healthy");

            document.getElementById("upstreams").innerHTML = data["result"].reduce((html, result) => {
                const upstream = result["metric"]["upstream"];
                const status = result["value"][1] === "1";

                const color = status ? "green" : "red";
                const mark = status ? "&#10003;" : "&#10799;";

                return html + ` <span style="color: ${color}">${upstream} ${mark}</span>`;
            }, "Erreichbarkeit:");
        }

        async function load_plots() {
            await Promise.all([
                load_requests_plot(),
                load_errors_plot(),
                load_duration_plot(),
                load_size_plot(),
                load_upstreams_table(),
            ]);
        }

        window.onload = load_plots;

        if (options.update_interval > 0) {
            window.setInterval(load_plots, options.update_interval * 1000);
        }
    </script>

    <title>Proxy</title>

    <style>
        body {
            font-family: sans-serif;
        }

        table {
            width: 100%;
        }

        td {
            width: 50%;
        }
    </style>
</head>

<body>
    <table>
        <tr>
            <td id="requests"></td>
            <td id="errors"></td>
        </tr>
        <tr>
            <td id="duration"></td>
            <td id="size"></td>
        </tr>
        <tr>
            <td id="upstreams"></td>
        </tr>
    </table>
</body>

</html>